## tl-expected 1.0.0~dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11)

project(tl-expected VERSION 1.0.0 LANGUAGES CXX)

option(EXPECTED_ENABLE_TESTS "Enable tests." ON)

include(FetchContent)
FetchContent_Declare(
  tl_cmake
  GIT_REPOSITORY https://github.com/TartanLlama/tl-cmake.git
)
FetchContent_GetProperties(tl_cmake)
if(NOT tl_cmake_POPULATED)
  FetchContent_Populate(tl_cmake)
  set(CMAKE_MODULE_PATH ${tl_cmake_SOURCE_DIR} ${CMAKE_MODULE_PATH})
endif()
include(add-tl)

tl_add_library(expected SOURCES 
               include/tl/expected.hpp)

# Prepare "Catch" library for other executables
set(CATCH_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/test)
add_library(Catch INTERFACE)
target_include_directories(Catch INTERFACE ${CATCH_INCLUDE_DIR})

if(EXPECTED_ENABLE_TESTS)
  # Make test executable
  set(TEST_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/tests/main.cpp
                   ${CMAKE_CURRENT_SOURCE_DIR}/tests/extensions.cpp
                   ${CMAKE_CURRENT_SOURCE_DIR}/tests/assignment.cpp
                   ${CMAKE_CURRENT_SOURCE_DIR}/tests/emplace.cpp
                   ${CMAKE_CURRENT_SOURCE_DIR}/tests/issues.cpp
                   ${CMAKE_CURRENT_SOURCE_DIR}/tests/bases.cpp
                   ${CMAKE_CURRENT_SOURCE_DIR}/tests/observers.cpp
                   ${CMAKE_CURRENT_SOURCE_DIR}/tests/swap.cpp
                   ${CMAKE_CURRENT_SOURCE_DIR}/tests/constructors.cpp)

  add_executable(tests ${TEST_SOURCES})

  target_link_libraries(tests Catch expected)

  set(CXXSTD 14 CACHE STRING "C++ standard to use, default C++14")
  set_property(TARGET tests PROPERTY CXX_STANDARD ${CXXSTD})
  set_property(TARGET tests PROPERTY CXX_FLAGS "-Wall -Wextra")
endif()

=== debian/changelog ===
tl-expected (1.0.0~dfsg-2) unstable; urgency=medium

  * Arch independent package version config.
    - This increases CMake minimal required version to 3.14.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sun, 26 Jan 2020 15:44:22 +0300

tl-expected (1.0.0~dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * No-change source-only upload to allow testing migration. 

 -- Boyuan Yang <byang@debian.org>  Thu, 23 Jan 2020 14:08:07 -0500

tl-expected (1.0.0~dfsg-1) unstable; urgency=low

  * Initial upload. (Closes: #949401)

 -- Nicholas Guriev <guriev-ns@ya.ru>  Wed, 22 Jan 2020 21:51:33 +0300

=== debian/control ===
Source: tl-expected
Section: libdevel
Priority: optional
Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
Build-Depends: debhelper-compat (= 12)
Build-Depends-Indep: catch <!nocheck>, cmake (>= 3.14)
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://tl.tartanllama.xyz/
Vcs-Git: https://salsa.debian.org/debian/tl-expected.git
Vcs-Browser: https://salsa.debian.org/debian/tl-expected

Package: libexpected-dev
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: C++11/14/17 std::expected with functional-style extensions
 Single header implementation of std::expected with functional-style extensions.
 .
 std::expected is proposed as the preferred way to represent object which will
 either have an expected value, or an unexpected value giving information about
 why something failed. Unfortunately, chaining together many computations which
 may fail can be verbose, as error-checking code will be mixed in with the
 actual programming logic. This implementation provides a number of utilities to
 make coding with expected cleaner.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk
EXTRA_CMAKE_VARIABLES += CMAKE_SKIP_INSTALL_ALL_DEPENDENCY=ON

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(EXTRA_CMAKE_VARIABLES:%=-D%)

ifneq ($(filter nocheck, $(DEB_BUILD_OPTIONS)),)
override_dh_auto_build:
else
override_dh_auto_test:
	obj-$(DEB_HOST_GNU_TYPE)/tests
endif

=== debian/watch ===
version=4
opts="\
        dversionmangle=s%~dfsg$%%, repacksuffix=~dfsg, \
        filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
    https://github.com/TartanLlama/expected/releases/latest \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## tl-expected 1.1.0

=== debian/changelog ===
tl-expected (1.1.0-2) unstable; urgency=medium

  * New Migrate-to-Catch2-v3.patch (Closes: #1054702)

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sat, 23 Dec 2023 12:55:48 +0300

tl-expected (1.1.0-1) unstable; urgency=medium

  * New upstream release.
  * Rewrite d/watch file for updated GitHub HTML code.
  * Remove previous patches, because they are no longer needed.
  * Build depend on catch2 instead of outdated catch.
  * New Prefer-packaged-Catch2.patch to avoid network access.
  * Add upstream metadata.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sun, 18 Jun 2023 00:23:17 +0300

tl-expected (1.0.0~dfsg-3) unstable; urgency=medium

  * New Include-memory-header.patch (Closes: #1016247)
  * Migrate to Debhelper compatibility level 13.
    - Remove explicit value of the CMAKE_SKIP_INSTALL_ALL_DEPENDENCY variable.
  * Bump Standards-Version to 4.6.1, no required changes.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sun, 31 Jul 2022 11:05:37 +0300

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Section: libdevel
 Priority: optional
 Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
-Build-Depends: debhelper-compat (= 12)
-Build-Depends-Indep: catch <!nocheck>, cmake (>= 3.14)
-Standards-Version: 4.5.0
+Build-Depends: debhelper-compat (= 13)
+Build-Depends-Indep: catch2 (>= 3.0.1) <!nocheck>, cmake (>= 3.14)
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Homepage: https://tl.tartanllama.xyz/
 Vcs-Git: https://salsa.debian.org/debian/tl-expected.git

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

ifneq ($(filter nocheck, $(DEB_BUILD_OPTIONS)),)
override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_TESTING=OFF
endif
